struct Material {
  //vec3 aColor;
  //vec3 dColor;
  //vec3 sColor;
  float shine;
};

//uniform int phong;
uniform sampler2D uTexUnit;
//uniform int water;
uniform int leaf;

varying vec4 vNorm;
varying vec4 vLight;
varying vec4 vView;
varying vec4 vRefl;
varying vec4 color;
varying vec2 vTexCoord;

uniform int normalOn;
uniform Material uMat;
uniform vec3 uLColor;

void main() {
  vec4 normNorm = normalize(vNorm);
  vec4 normLight = normalize(vLight);
  vec4 normView = normalize(vView);
  vec4 normRefl = normalize(vRefl);
  vec4 texColor1 = texture2D(uTexUnit, vTexCoord);
  
  if(leaf == 1) {
    if(texColor1[0] < 0.1 && texColor1[0] < 0.1 && texColor1[0] < 0.1) {
        discard;
    }
    else {
        gl_FragColor = vec4(max(dot(normNorm, normLight), 0.0)*uLColor, 1)*texColor1 + vec4(pow(max(dot(normView, normRefl), 0.0), uMat.shine)*uLColor, 1)*texColor1 + texColor1*vec4(0.5*uLColor, 1);
    }
  }
  else {

     gl_FragColor = vec4(max(dot(normNorm, normLight), 0.0)*uLColor, 1)*texColor1 + vec4(pow(max(dot(normView, normRefl), 0.0), uMat.shine)*uLColor, 1)*texColor1 + texColor1*vec4(0.5*uLColor, 1);
  }
}
